##// END OF EJS Templates
bash -> sh change fix...
Unknown -
r393:b6c2d8edb04b
parent child
Show More
@@ -1,830 +1,833
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 #Kernel Branch
48 #Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 #BIS= Kernel has KVM and zswap enabled
59 #BIS= Kernel has KVM and zswap enabled
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
60 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
61 #default bcmrpi3_defconfig target kernel
61 #default bcmrpi3_defconfig target kernel
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
62 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
63 #enhanced kernel
63 #enhanced kernel
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
64 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_BIS_KERNEL_URL}
65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
65 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
66
66
67 # Build directories
67 # Build directories
68 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
68 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
69 BUILDDIR="${BASEDIR}/build"
69 BUILDDIR="${BASEDIR}/build"
70
70
71 # Prepare date string for default image file name
71 # Prepare date string for default image file name
72 DATE="$(date +%Y-%m-%d)"
72 DATE="$(date +%Y-%m-%d)"
73 if [ -z "$KERNEL_BRANCH" ] ; then
73 if [ -z "$KERNEL_BRANCH" ] ; then
74 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
74 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
75 else
75 else
76 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
76 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
77 fi
77 fi
78
78
79 # Chroot directories
79 # Chroot directories
80 R="${BUILDDIR}/chroot"
80 R="${BUILDDIR}/chroot"
81 ETC_DIR="${R}/etc"
81 ETC_DIR="${R}/etc"
82 LIB_DIR="${R}/lib"
82 LIB_DIR="${R}/lib"
83 BOOT_DIR="${R}/boot/firmware"
83 BOOT_DIR="${R}/boot/firmware"
84 KERNEL_DIR="${R}/usr/src/linux"
84 KERNEL_DIR="${R}/usr/src/linux"
85 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
85 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
86
86
87 # Firmware directory: Blank if download from github
87 # Firmware directory: Blank if download from github
88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
89
89
90 # General settings
90 # General settings
91 SET_ARCH=${SET_ARCH:=32}
91 SET_ARCH=${SET_ARCH:=32}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
93 PASSWORD=${PASSWORD:=raspberry}
93 PASSWORD=${PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
97 EXPANDROOT=${EXPANDROOT:=true}
97 EXPANDROOT=${EXPANDROOT:=true}
98
98
99 # Keyboard settings
99 # Keyboard settings
100 XKB_MODEL=${XKB_MODEL:=""}
100 XKB_MODEL=${XKB_MODEL:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
104
104
105 # Network settings (DHCP)
105 # Network settings (DHCP)
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
107
107
108 # Network settings (static)
108 # Network settings (static)
109 NET_ADDRESS=${NET_ADDRESS:=""}
109 NET_ADDRESS=${NET_ADDRESS:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
116
116
117 # APT settings
117 # APT settings
118 APT_PROXY=${APT_PROXY:=""}
118 APT_PROXY=${APT_PROXY:=""}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
120
120
121 # Feature settings
121 # Feature settings
122 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
122 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
123 ENABLE_I2C=${ENABLE_I2C:=false}
123 ENABLE_I2C=${ENABLE_I2C:=false}
124 ENABLE_SPI=${ENABLE_SPI:=false}
124 ENABLE_SPI=${ENABLE_SPI:=false}
125 ENABLE_IPV6=${ENABLE_IPV6:=true}
125 ENABLE_IPV6=${ENABLE_IPV6:=true}
126 ENABLE_SSHD=${ENABLE_SSHD:=true}
126 ENABLE_SSHD=${ENABLE_SSHD:=true}
127 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
127 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
128 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
129 ENABLE_SOUND=${ENABLE_SOUND:=true}
129 ENABLE_SOUND=${ENABLE_SOUND:=true}
130 ENABLE_DBUS=${ENABLE_DBUS:=true}
130 ENABLE_DBUS=${ENABLE_DBUS:=true}
131 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
131 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
132 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
132 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
133 ENABLE_XORG=${ENABLE_XORG:=false}
133 ENABLE_XORG=${ENABLE_XORG:=false}
134 ENABLE_WM=${ENABLE_WM:=""}
134 ENABLE_WM=${ENABLE_WM:=""}
135 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
135 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
136 ENABLE_USER=${ENABLE_USER:=true}
136 ENABLE_USER=${ENABLE_USER:=true}
137 USER_NAME=${USER_NAME:="pi"}
137 USER_NAME=${USER_NAME:="pi"}
138 ENABLE_ROOT=${ENABLE_ROOT:=false}
138 ENABLE_ROOT=${ENABLE_ROOT:=false}
139 ENABLE_QEMU=${ENABLE_QEMU:=false}
139 ENABLE_QEMU=${ENABLE_QEMU:=false}
140 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
140 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
141
141
142 # SSH settings
142 # SSH settings
143 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
143 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
144 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
144 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
145 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
145 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
146 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
146 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
147 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
147 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
148
148
149 # Advanced settings
149 # Advanced settings
150 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
150 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
151 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
151 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
152 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
152 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
153 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
153 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
154 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
154 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
155 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
155 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
156 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
156 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=true}
157 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
157 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
158 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
158 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
159 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
159 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
160 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
160 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
161 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
161 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
162 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
162 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
163 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
163 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
164 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
164 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
165
165
166 # Kernel compilation settings
166 # Kernel compilation settings
167 BUILD_KERNEL=${BUILD_KERNEL:=true}
167 BUILD_KERNEL=${BUILD_KERNEL:=true}
168 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
168 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
169 KERNEL_THREADS=${KERNEL_THREADS:=1}
169 KERNEL_THREADS=${KERNEL_THREADS:=1}
170 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
170 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
171 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
171 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
172 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
172 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
173 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
173 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
174 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
174 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
175 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
175 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
176 KERNEL_VIRT=${KERNEL_VIRT:=false}
176 KERNEL_VIRT=${KERNEL_VIRT:=false}
177 KERNEL_BPF=${KERNEL_BPF:=true}
177 KERNEL_BPF=${KERNEL_BPF:=true}
178
178
179 # Kernel compilation from source directory settings
179 # Kernel compilation from source directory settings
180 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
180 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
181 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
181 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
182 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
182 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
183 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
183 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
184
184
185 # Reduce disk usage settings
185 # Reduce disk usage settings
186 REDUCE_APT=${REDUCE_APT:=true}
186 REDUCE_APT=${REDUCE_APT:=true}
187 REDUCE_DOC=${REDUCE_DOC:=true}
187 REDUCE_DOC=${REDUCE_DOC:=true}
188 REDUCE_MAN=${REDUCE_MAN:=true}
188 REDUCE_MAN=${REDUCE_MAN:=true}
189 REDUCE_VIM=${REDUCE_VIM:=false}
189 REDUCE_VIM=${REDUCE_VIM:=false}
190 REDUCE_BASH=${REDUCE_BASH:=false}
190 REDUCE_BASH=${REDUCE_BASH:=false}
191 REDUCE_HWDB=${REDUCE_HWDB:=true}
191 REDUCE_HWDB=${REDUCE_HWDB:=true}
192 REDUCE_SSHD=${REDUCE_SSHD:=true}
192 REDUCE_SSHD=${REDUCE_SSHD:=true}
193 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
193 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
194
194
195 # Encrypted filesystem settings
195 # Encrypted filesystem settings
196 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
196 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
197 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
197 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
198 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
198 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
199 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
199 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
200 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
200 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
201
201
202 # Chroot scripts directory
202 # Chroot scripts directory
203 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
203 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
204
204
205 # Packages required in the chroot build environment
205 # Packages required in the chroot build environment
206 APT_INCLUDES=${APT_INCLUDES:=""}
206 APT_INCLUDES=${APT_INCLUDES:=""}
207 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
207 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
208
208
209 #Packages to exclude from chroot build environment
209 #Packages to exclude from chroot build environment
210 APT_EXCLUDES=${APT_EXCLUDES:=""}
210 APT_EXCLUDES=${APT_EXCLUDES:=""}
211
211
212 # Packages required for bootstrapping
212 # Packages required for bootstrapping
213 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
213 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
214 MISSING_PACKAGES=""
214 MISSING_PACKAGES=""
215
215
216 # Packages installed for c/c++ build environment in chroot (keep empty)
216 # Packages installed for c/c++ build environment in chroot (keep empty)
217 COMPILER_PACKAGES=""
217 COMPILER_PACKAGES=""
218
218
219 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
219 #If init and systemd-sysv are wanted e.g. halt/reboot/shutdown scripts
220 if [ "$ENABLE_SYSVINIT" = false ] ; then
220 if [ "$ENABLE_SYSVINIT" = false ] ; then
221 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
221 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
222 fi
222 fi
223
223
224 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
224 #Check if apt-cacher-ng has its default port open on and set APT_PROXY
225 if [ -n "$(lsof -i :3142)" ] ; then
225 if [ -n "$(lsof -i :3142)" ] ; then
226 HTTP_PROXY=http://127.0.0.1:3142/
226 HTTP_PROXY=http://127.0.0.1:3142/
227 fi
227 fi
228
228
229 #ipinfo=$(curl ipinfo.io | grep country )
229 #ipinfo=$(curl ipinfo.io | grep country )
230 #grep -o '\"[^"]*\"' $ipinfo | tr -d '"'
230 #grep -o '\"[^"]*\"' $ipinfo | tr -d '"'
231 #grep -Po '"country":.*?[^\\]",' $(curl ipinfo.io | grep country )
231 #grep -Po '"country":.*?[^\\]",' $(curl ipinfo.io | grep country )
232 #sed -i "s,http:,https:,g" "${ETC_DIR}/apt/sources.list"
232 #sed -i "s,http:,https:,g" "${ETC_DIR}/apt/sources.list"
233 #autconfigure best apt server to not spam ftp.debian.org
233 #autconfigure best apt server to not spam ftp.debian.org
234 #rm files/apt/sources.list
234 #rm files/apt/sources.list
235 #netselect-apt does not know buster yet
235 #netselect-apt does not know buster yet
236 if [ "$RELEASE" = "buster" ] ; then
236 if [ "$RELEASE" = "buster" ] ; then
237 RLS=testing
237 RLS=testing
238 else
238 else
239 RLS="$RELEASE"
239 RLS="$RELEASE"
240 fi
240 fi
241
241
242 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
242 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
243 rm "$(pwd)/files/apt/sources.list"
243 rm "$(pwd)/files/apt/sources.list"
244 fi
244 fi
245
245
246 if [ "$ENABLE_NONFREE" = true ] ; then
246 if [ "$ENABLE_NONFREE" = true ] ; then
247 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
247 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
248 else
248 else
249 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
249 netselect-apt --arch "$RELEASE_ARCH" --tests 10 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
250 fi
250 fi
251
251
252 #sed and cut the result string so we can use it as APT_SERVER
252 #sed and cut the result string so we can use it as APT_SERVER
253 tmp=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3)
253 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3)
254 APT_SERVER=${tmp:0:-1}
254 #non sh compatible
255 #APT_SERVER=${tmp:0:-1}
256 #sh compatible
257 APT_SERVER=echo "$APT_SERVER" | sed 's|/$|''|'
255
258
256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
259 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
257 if [ -n "$SET_ARCH" ] ; then
260 if [ -n "$SET_ARCH" ] ; then
258 echo "Setting Architecture specific settings"
261 echo "Setting Architecture specific settings"
259 ##################################
262 ##################################
260 # 64 bit config
263 # 64 bit config
261 ##################################
264 ##################################
262 if [ "$SET_ARCH" = 64 ] ; then
265 if [ "$SET_ARCH" = 64 ] ; then
263 echo "64 bit mode selected - Setting up enviroment"
266 echo "64 bit mode selected - Setting up enviroment"
264 # 64 bit depended settings
267 # 64 bit depended settings
265 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
268 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
266 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
269 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
267 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
270 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
268
271
269 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
272 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
270 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
273 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
271 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
274 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
272 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
275 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
273 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
276 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
274 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
277 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
275 else
278 else
276 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
279 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
277 exit 1
280 exit 1
278 fi
281 fi
279 fi
282 fi
280
283
281 ##################################
284 ##################################
282 # 32 bit config
285 # 32 bit config
283 ##################################
286 ##################################
284 if [ "$SET_ARCH" = 32 ] ; then
287 if [ "$SET_ARCH" = 32 ] ; then
285 echo "32 bit mode selected - Setting up enviroment"
288 echo "32 bit mode selected - Setting up enviroment"
286 #General 32bit configuration
289 #General 32bit configuration
287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
290 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
291 KERNEL_ARCH=${KERNEL_ARCH:=arm}
289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
292 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
290
293
291 #Raspberry setting grouped by board compability
294 #Raspberry setting grouped by board compability
292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
295 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
293 echo "Setting settings for bcm2835 Raspberry PI boards"
296 echo "Setting settings for bcm2835 Raspberry PI boards"
294 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
297 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
295 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
298 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
296 RELEASE_ARCH=${RELEASE_ARCH:=armel}
299 RELEASE_ARCH=${RELEASE_ARCH:=armel}
297 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
300 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
298 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
301 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
299 fi
302 fi
300 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
303 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
301 echo "Setting settings for bcm2837 Raspberry PI boards"
304 echo "Setting settings for bcm2837 Raspberry PI boards"
302 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
305 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
306 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
304 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
307 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
305 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
308 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
306 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
309 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
307 fi
310 fi
308 fi
311 fi
309 #SET_ARCH not set
312 #SET_ARCH not set
310 else
313 else
311 echo "error: Please set '32' or '64' as value for SET_ARCH"
314 echo "error: Please set '32' or '64' as value for SET_ARCH"
312 exit 1
315 exit 1
313 fi
316 fi
314
317
315 #Device specific configuration
318 #Device specific configuration
316 echo "Select DTB-File"
319 echo "Select DTB-File"
317 case "$RPI_MODEL" in
320 case "$RPI_MODEL" in
318 0)
321 0)
319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
322 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
321 ;;
324 ;;
322 1)
325 1)
323 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
326 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
325 ;;
328 ;;
326 1P)
329 1P)
327 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
330 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
331 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
329 ;;
332 ;;
330 2)
333 2)
331 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
334 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
335 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
333 ;;
336 ;;
334 3)
337 3)
335 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
338 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
336 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
339 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
337 ;;
340 ;;
338 3P)
341 3P)
339 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
342 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
340 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
343 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
341 ;;
344 ;;
342 *)
345 *)
343 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
346 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
344 exit 1
347 exit 1
345 ;;
348 ;;
346 esac
349 esac
347 echo "$DTB_FILE selected"
350 echo "$DTB_FILE selected"
348
351
349 #DEBUG off
352 #DEBUG off
350 set +x
353 set +x
351
354
352 # Check if the internal wireless interface is supported by the RPi model
355 # Check if the internal wireless interface is supported by the RPi model
353 if [ "$ENABLE_WIRELESS" = true ] ; then
356 if [ "$ENABLE_WIRELESS" = true ] ; then
354 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
357 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
355 echo "error: The selected Raspberry Pi model has no internal wireless interface"
358 echo "error: The selected Raspberry Pi model has no internal wireless interface"
356 exit 1
359 exit 1
357 else
360 else
358 echo "Raspberry Pi $RPI_MODEL has WIFI support"
361 echo "Raspberry Pi $RPI_MODEL has WIFI support"
359 fi
362 fi
360 fi
363 fi
361
364
362 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
365 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
363 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
366 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
364 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
367 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
365 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
368 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
366 exit 1
369 exit 1
367 fi
370 fi
368 fi
371 fi
369
372
370 if [ "$ENABLE_VIDEOCORE" = true ] ; then
373 if [ "$ENABLE_VIDEOCORE" = true ] ; then
371 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
374 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
372 fi
375 fi
373
376
374 # Add libncurses5 to enable kernel menuconfig
377 # Add libncurses5 to enable kernel menuconfig
375 if [ "$KERNEL_MENUCONFIG" = true ] ; then
378 if [ "$KERNEL_MENUCONFIG" = true ] ; then
376 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
377 fi
380 fi
378
381
379 # Add ccache compiler cache for (faster) kernel cross (re)compilation
382 # Add ccache compiler cache for (faster) kernel cross (re)compilation
380 if [ "$KERNEL_CCACHE" = true ] ; then
383 if [ "$KERNEL_CCACHE" = true ] ; then
381 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
382 fi
385 fi
383
386
384 # Add cryptsetup package to enable filesystem encryption
387 # Add cryptsetup package to enable filesystem encryption
385 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
388 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
386 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
387 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
390 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
388
391
389 if [ -z "$CRYPTFS_PASSWORD" ] ; then
392 if [ -z "$CRYPTFS_PASSWORD" ] ; then
390 echo "error: no password defined (CRYPTFS_PASSWORD)!"
393 echo "error: no password defined (CRYPTFS_PASSWORD)!"
391 exit 1
394 exit 1
392 fi
395 fi
393 ENABLE_INITRAMFS=true
396 ENABLE_INITRAMFS=true
394 fi
397 fi
395
398
396 # Add initramfs generation tools
399 # Add initramfs generation tools
397 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
400 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
398 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
401 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
399 fi
402 fi
400
403
401 # Add device-tree-compiler required for building the U-Boot bootloader
404 # Add device-tree-compiler required for building the U-Boot bootloader
402 if [ "$ENABLE_UBOOT" = true ] ; then
405 if [ "$ENABLE_UBOOT" = true ] ; then
403 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
406 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
404 else
407 else
405 if [ "$ENABLE_UBOOTUSB" = true ] ; then
408 if [ "$ENABLE_UBOOTUSB" = true ] ; then
406 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
409 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
407 exit 1
410 exit 1
408 fi
411 fi
409 fi
412 fi
410
413
411 # Check if root SSH (v2) public key file exists
414 # Check if root SSH (v2) public key file exists
412 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
415 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
413 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
416 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
414 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
417 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
415 exit 1
418 exit 1
416 fi
419 fi
417 fi
420 fi
418
421
419 # Check if $USER_NAME SSH (v2) public key file exists
422 # Check if $USER_NAME SSH (v2) public key file exists
420 if [ -n "$SSH_USER_PUB_KEY" ] ; then
423 if [ -n "$SSH_USER_PUB_KEY" ] ; then
421 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
424 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
422 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
425 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
423 exit 1
426 exit 1
424 fi
427 fi
425 fi
428 fi
426
429
427 # Check if all required packages are installed on the build system
430 # Check if all required packages are installed on the build system
428 for package in $REQUIRED_PACKAGES ; do
431 for package in $REQUIRED_PACKAGES ; do
429 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
432 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
430 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
433 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
431 fi
434 fi
432 done
435 done
433
436
434 # If there are missing packages ask confirmation for install, or exit
437 # If there are missing packages ask confirmation for install, or exit
435 if [ -n "$MISSING_PACKAGES" ] ; then
438 if [ -n "$MISSING_PACKAGES" ] ; then
436 echo "the following packages needed by this script are not installed:"
439 echo "the following packages needed by this script are not installed:"
437 echo "$MISSING_PACKAGES"
440 echo "$MISSING_PACKAGES"
438
441
439 printf "\ndo you want to install the missing packages right now? [y/n] "
442 printf "\ndo you want to install the missing packages right now? [y/n] "
440 read -r confirm
443 read -r confirm
441 [ "$confirm" != "y" ] && exit 1
444 [ "$confirm" != "y" ] && exit 1
442
445
443 # Make sure all missing required packages are installed
446 # Make sure all missing required packages are installed
444 apt-get -qq -y install "${MISSING_PACKAGES}"
447 apt-get -qq -y install "${MISSING_PACKAGES}"
445 fi
448 fi
446
449
447 # Check if ./bootstrap.d directory exists
450 # Check if ./bootstrap.d directory exists
448 if [ ! -d "./bootstrap.d/" ] ; then
451 if [ ! -d "./bootstrap.d/" ] ; then
449 echo "error: './bootstrap.d' required directory not found!"
452 echo "error: './bootstrap.d' required directory not found!"
450 exit 1
453 exit 1
451 fi
454 fi
452
455
453 # Check if ./files directory exists
456 # Check if ./files directory exists
454 if [ ! -d "./files/" ] ; then
457 if [ ! -d "./files/" ] ; then
455 echo "error: './files' required directory not found!"
458 echo "error: './files' required directory not found!"
456 exit 1
459 exit 1
457 fi
460 fi
458
461
459 # Check if specified KERNELSRC_DIR directory exists
462 # Check if specified KERNELSRC_DIR directory exists
460 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
463 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
461 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
464 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
462 exit 1
465 exit 1
463 fi
466 fi
464
467
465 # Check if specified UBOOTSRC_DIR directory exists
468 # Check if specified UBOOTSRC_DIR directory exists
466 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
469 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
467 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
470 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
468 exit 1
471 exit 1
469 fi
472 fi
470
473
471 # Check if specified VIDEOCORESRC_DIR directory exists
474 # Check if specified VIDEOCORESRC_DIR directory exists
472 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
475 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
473 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
476 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
474 exit 1
477 exit 1
475 fi
478 fi
476
479
477 # Check if specified FBTURBOSRC_DIR directory exists
480 # Check if specified FBTURBOSRC_DIR directory exists
478 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
481 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
479 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
482 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
480 exit 1
483 exit 1
481 fi
484 fi
482
485
483 # Check if specified CHROOT_SCRIPTS directory exists
486 # Check if specified CHROOT_SCRIPTS directory exists
484 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
487 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
485 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
488 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
486 exit 1
489 exit 1
487 fi
490 fi
488
491
489 # Check if specified device mapping already exists (will be used by cryptsetup)
492 # Check if specified device mapping already exists (will be used by cryptsetup)
490 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
493 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
491 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
494 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
492 exit 1
495 exit 1
493 fi
496 fi
494
497
495 # Don't clobber an old build
498 # Don't clobber an old build
496 if [ -e "$BUILDDIR" ] ; then
499 if [ -e "$BUILDDIR" ] ; then
497 echo "error: directory ${BUILDDIR} already exists, not proceeding"
500 echo "error: directory ${BUILDDIR} already exists, not proceeding"
498 exit 1
501 exit 1
499 fi
502 fi
500
503
501 # Setup chroot directory
504 # Setup chroot directory
502 mkdir -p "${R}"
505 mkdir -p "${R}"
503
506
504 # Check if build directory has enough of free disk space >512MB
507 # Check if build directory has enough of free disk space >512MB
505 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
508 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
506 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
509 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
507 exit 1
510 exit 1
508 fi
511 fi
509
512
510 set -x
513 set -x
511
514
512 # Call "cleanup" function on various signals and errors
515 # Call "cleanup" function on various signals and errors
513 trap cleanup 0 1 2 3 6
516 trap cleanup 0 1 2 3 6
514
517
515 # Add required packages for the minbase installation
518 # Add required packages for the minbase installation
516 if [ "$ENABLE_MINBASE" = true ] ; then
519 if [ "$ENABLE_MINBASE" = true ] ; then
517 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
520 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
518 fi
521 fi
519
522
520 # Add parted package, required to get partprobe utility
523 # Add parted package, required to get partprobe utility
521 if [ "$EXPANDROOT" = true ] ; then
524 if [ "$EXPANDROOT" = true ] ; then
522 APT_INCLUDES="${APT_INCLUDES},parted"
525 APT_INCLUDES="${APT_INCLUDES},parted"
523 fi
526 fi
524
527
525 # Add dbus package, recommended if using systemd
528 # Add dbus package, recommended if using systemd
526 if [ "$ENABLE_DBUS" = true ] ; then
529 if [ "$ENABLE_DBUS" = true ] ; then
527 APT_INCLUDES="${APT_INCLUDES},dbus"
530 APT_INCLUDES="${APT_INCLUDES},dbus"
528 fi
531 fi
529
532
530 # Add iptables IPv4/IPv6 package
533 # Add iptables IPv4/IPv6 package
531 if [ "$ENABLE_IPTABLES" = true ] ; then
534 if [ "$ENABLE_IPTABLES" = true ] ; then
532 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
535 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
533 fi
536 fi
534
537
535 # Add openssh server package
538 # Add openssh server package
536 if [ "$ENABLE_SSHD" = true ] ; then
539 if [ "$ENABLE_SSHD" = true ] ; then
537 APT_INCLUDES="${APT_INCLUDES},openssh-server"
540 APT_INCLUDES="${APT_INCLUDES},openssh-server"
538 fi
541 fi
539
542
540 # Add alsa-utils package
543 # Add alsa-utils package
541 if [ "$ENABLE_SOUND" = true ] ; then
544 if [ "$ENABLE_SOUND" = true ] ; then
542 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
545 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
543 fi
546 fi
544
547
545 # Add rng-tools package
548 # Add rng-tools package
546 if [ "$ENABLE_HWRANDOM" = true ] ; then
549 if [ "$ENABLE_HWRANDOM" = true ] ; then
547 APT_INCLUDES="${APT_INCLUDES},rng-tools"
550 APT_INCLUDES="${APT_INCLUDES},rng-tools"
548 fi
551 fi
549
552
550 # Add fbturbo video driver
553 # Add fbturbo video driver
551 if [ "$ENABLE_FBTURBO" = true ] ; then
554 if [ "$ENABLE_FBTURBO" = true ] ; then
552 # Enable xorg package dependencies
555 # Enable xorg package dependencies
553 ENABLE_XORG=true
556 ENABLE_XORG=true
554 fi
557 fi
555
558
556 # Add user defined window manager package
559 # Add user defined window manager package
557 if [ -n "$ENABLE_WM" ] ; then
560 if [ -n "$ENABLE_WM" ] ; then
558 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
561 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
559
562
560 # Enable xorg package dependencies
563 # Enable xorg package dependencies
561 ENABLE_XORG=true
564 ENABLE_XORG=true
562 fi
565 fi
563
566
564 # Add xorg package
567 # Add xorg package
565 if [ "$ENABLE_XORG" = true ] ; then
568 if [ "$ENABLE_XORG" = true ] ; then
566 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
569 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
567 fi
570 fi
568
571
569 # Replace selected packages with smaller clones
572 # Replace selected packages with smaller clones
570 if [ "$ENABLE_REDUCE" = true ] ; then
573 if [ "$ENABLE_REDUCE" = true ] ; then
571 # Add levee package instead of vim-tiny
574 # Add levee package instead of vim-tiny
572 if [ "$REDUCE_VIM" = true ] ; then
575 if [ "$REDUCE_VIM" = true ] ; then
573 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
576 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
574 fi
577 fi
575
578
576 # Add dropbear package instead of openssh-server
579 # Add dropbear package instead of openssh-server
577 if [ "$REDUCE_SSHD" = true ] ; then
580 if [ "$REDUCE_SSHD" = true ] ; then
578 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
581 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
579 fi
582 fi
580 fi
583 fi
581
584
582 # Configure kernel sources if no KERNELSRC_DIR
585 # Configure kernel sources if no KERNELSRC_DIR
583 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
586 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
584 KERNELSRC_CONFIG=true
587 KERNELSRC_CONFIG=true
585 fi
588 fi
586
589
587 # Configure reduced kernel
590 # Configure reduced kernel
588 if [ "$KERNEL_REDUCE" = true ] ; then
591 if [ "$KERNEL_REDUCE" = true ] ; then
589 KERNELSRC_CONFIG=false
592 KERNELSRC_CONFIG=false
590 fi
593 fi
591
594
592 # Configure qemu compatible kernel
595 # Configure qemu compatible kernel
593 if [ "$ENABLE_QEMU" = true ] ; then
596 if [ "$ENABLE_QEMU" = true ] ; then
594 DTB_FILE=vexpress-v2p-ca15_a7.dtb
597 DTB_FILE=vexpress-v2p-ca15_a7.dtb
595 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
598 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
596 KERNEL_DEFCONFIG="vexpress_defconfig"
599 KERNEL_DEFCONFIG="vexpress_defconfig"
597 if [ "$KERNEL_MENUCONFIG" = false ] ; then
600 if [ "$KERNEL_MENUCONFIG" = false ] ; then
598 KERNEL_OLDDEFCONFIG=true
601 KERNEL_OLDDEFCONFIG=true
599 fi
602 fi
600 fi
603 fi
601
604
602 # Execute bootstrap scripts
605 # Execute bootstrap scripts
603 for SCRIPT in bootstrap.d/*.sh; do
606 for SCRIPT in bootstrap.d/*.sh; do
604 head -n 3 "$SCRIPT"
607 head -n 3 "$SCRIPT"
605 . "$SCRIPT"
608 . "$SCRIPT"
606 done
609 done
607
610
608 ## Execute custom bootstrap scripts
611 ## Execute custom bootstrap scripts
609 if [ -d "custom.d" ] ; then
612 if [ -d "custom.d" ] ; then
610 for SCRIPT in custom.d/*.sh; do
613 for SCRIPT in custom.d/*.sh; do
611 . "$SCRIPT"
614 . "$SCRIPT"
612 done
615 done
613 fi
616 fi
614
617
615 # Execute custom scripts inside the chroot
618 # Execute custom scripts inside the chroot
616 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
619 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
617 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
620 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
618 chroot_exec /bin/bash -x <<'EOF'
621 chroot_exec /bin/bash -x <<'EOF'
619 for SCRIPT in /chroot_scripts/* ; do
622 for SCRIPT in /chroot_scripts/* ; do
620 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
623 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
621 $SCRIPT
624 $SCRIPT
622 fi
625 fi
623 done
626 done
624 EOF
627 EOF
625 rm -rf "${R}/chroot_scripts"
628 rm -rf "${R}/chroot_scripts"
626 fi
629 fi
627
630
628 # Remove c/c++ build environment from the chroot
631 # Remove c/c++ build environment from the chroot
629 chroot_remove_cc
632 chroot_remove_cc
630
633
631 # Generate required machine-id
634 # Generate required machine-id
632 MACHINE_ID=$(dbus-uuidgen)
635 MACHINE_ID=$(dbus-uuidgen)
633 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
636 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
634 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
637 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
635
638
636 # APT Cleanup
639 # APT Cleanup
637 chroot_exec apt-get -y clean
640 chroot_exec apt-get -y clean
638 chroot_exec apt-get -y autoclean
641 chroot_exec apt-get -y autoclean
639 chroot_exec apt-get -y autoremove
642 chroot_exec apt-get -y autoremove
640
643
641 # Unmount mounted filesystems
644 # Unmount mounted filesystems
642 umount -l "${R}/proc"
645 umount -l "${R}/proc"
643 umount -l "${R}/sys"
646 umount -l "${R}/sys"
644
647
645 # Clean up directories
648 # Clean up directories
646 rm -rf "${R}/run/*"
649 rm -rf "${R}/run/*"
647 rm -rf "${R}/tmp/*"
650 rm -rf "${R}/tmp/*"
648
651
649 # Clean up files
652 # Clean up files
650 rm -f "${ETC_DIR}/ssh/ssh_host_*"
653 rm -f "${ETC_DIR}/ssh/ssh_host_*"
651 rm -f "${ETC_DIR}/dropbear/dropbear_*"
654 rm -f "${ETC_DIR}/dropbear/dropbear_*"
652 rm -f "${ETC_DIR}/apt/sources.list.save"
655 rm -f "${ETC_DIR}/apt/sources.list.save"
653 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
656 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
654 rm -f "${ETC_DIR}/*-"
657 rm -f "${ETC_DIR}/*-"
655 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
658 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
656 rm -f "${ETC_DIR}/resolv.conf"
659 rm -f "${ETC_DIR}/resolv.conf"
657 rm -f "${R}/root/.bash_history"
660 rm -f "${R}/root/.bash_history"
658 rm -f "${R}/var/lib/urandom/random-seed"
661 rm -f "${R}/var/lib/urandom/random-seed"
659 rm -f "${R}/initrd.img"
662 rm -f "${R}/initrd.img"
660 rm -f "${R}/vmlinuz"
663 rm -f "${R}/vmlinuz"
661 rm -f "${R}${QEMU_BINARY}"
664 rm -f "${R}${QEMU_BINARY}"
662
665
663 if [ "$ENABLE_QEMU" = true ] ; then
666 if [ "$ENABLE_QEMU" = true ] ; then
664 # Setup QEMU directory
667 # Setup QEMU directory
665 mkdir "${BASEDIR}/qemu"
668 mkdir "${BASEDIR}/qemu"
666
669
667 # Copy kernel image to QEMU directory
670 # Copy kernel image to QEMU directory
668 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
671 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
669
672
670 # Copy kernel config to QEMU directory
673 # Copy kernel config to QEMU directory
671 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
674 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
672
675
673 # Copy kernel dtbs to QEMU directory
676 # Copy kernel dtbs to QEMU directory
674 for dtb in "${BOOT_DIR}/"*.dtb ; do
677 for dtb in "${BOOT_DIR}/"*.dtb ; do
675 if [ -f "${dtb}" ] ; then
678 if [ -f "${dtb}" ] ; then
676 install_readonly "${dtb}" "${BASEDIR}/qemu/"
679 install_readonly "${dtb}" "${BASEDIR}/qemu/"
677 fi
680 fi
678 done
681 done
679
682
680 # Copy kernel overlays to QEMU directory
683 # Copy kernel overlays to QEMU directory
681 if [ -d "${BOOT_DIR}/overlays" ] ; then
684 if [ -d "${BOOT_DIR}/overlays" ] ; then
682 # Setup overlays dtbs directory
685 # Setup overlays dtbs directory
683 mkdir "${BASEDIR}/qemu/overlays"
686 mkdir "${BASEDIR}/qemu/overlays"
684
687
685 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
688 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
686 if [ -f "${dtb}" ] ; then
689 if [ -f "${dtb}" ] ; then
687 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
690 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
688 fi
691 fi
689 done
692 done
690 fi
693 fi
691
694
692 # Copy u-boot files to QEMU directory
695 # Copy u-boot files to QEMU directory
693 if [ "$ENABLE_UBOOT" = true ] ; then
696 if [ "$ENABLE_UBOOT" = true ] ; then
694 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
697 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
695 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
698 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
696 fi
699 fi
697 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
700 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
698 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
701 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
699 fi
702 fi
700 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
703 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
701 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
704 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
702 fi
705 fi
703 fi
706 fi
704
707
705 # Copy initramfs to QEMU directory
708 # Copy initramfs to QEMU directory
706 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
709 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
707 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
710 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
708 fi
711 fi
709 fi
712 fi
710
713
711 # Calculate size of the chroot directory in KB
714 # Calculate size of the chroot directory in KB
712 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
715 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
713
716
714 # Calculate the amount of needed 512 Byte sectors
717 # Calculate the amount of needed 512 Byte sectors
715 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
718 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
716 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
719 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
717 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
720 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
718
721
719 # The root partition is EXT4
722 # The root partition is EXT4
720 # This means more space than the actual used space of the chroot is used.
723 # This means more space than the actual used space of the chroot is used.
721 # As overhead for journaling and reserved blocks 35% are added.
724 # As overhead for journaling and reserved blocks 35% are added.
722 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
725 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
723
726
724 # Calculate required image size in 512 Byte sectors
727 # Calculate required image size in 512 Byte sectors
725 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
728 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
726
729
727 # Prepare image file
730 # Prepare image file
728 if [ "$ENABLE_SPLITFS" = true ] ; then
731 if [ "$ENABLE_SPLITFS" = true ] ; then
729 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
732 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
730 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
733 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
731 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
734 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
732 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
735 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
733
736
734 # Write firmware/boot partition tables
737 # Write firmware/boot partition tables
735 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
738 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
736 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
739 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
737 EOM
740 EOM
738
741
739 # Write root partition table
742 # Write root partition table
740 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
743 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
741 ${TABLE_SECTORS},${ROOT_SECTORS},83
744 ${TABLE_SECTORS},${ROOT_SECTORS},83
742 EOM
745 EOM
743
746
744 # Setup temporary loop devices
747 # Setup temporary loop devices
745 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
748 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
746 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
749 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
747 else # ENABLE_SPLITFS=false
750 else # ENABLE_SPLITFS=false
748 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
751 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
749 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
752 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
750
753
751 # Write partition table
754 # Write partition table
752 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
755 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
753 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
756 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
754 ${ROOT_OFFSET},${ROOT_SECTORS},83
757 ${ROOT_OFFSET},${ROOT_SECTORS},83
755 EOM
758 EOM
756
759
757 # Setup temporary loop devices
760 # Setup temporary loop devices
758 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
761 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
759 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
762 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
760 fi
763 fi
761
764
762 if [ "$ENABLE_CRYPTFS" = true ] ; then
765 if [ "$ENABLE_CRYPTFS" = true ] ; then
763 # Create dummy ext4 fs
766 # Create dummy ext4 fs
764 mkfs.ext4 "$ROOT_LOOP"
767 mkfs.ext4 "$ROOT_LOOP"
765
768
766 # Setup password keyfile
769 # Setup password keyfile
767 touch .password
770 touch .password
768 chmod 600 .password
771 chmod 600 .password
769 echo -n ${CRYPTFS_PASSWORD} > .password
772 echo -n ${CRYPTFS_PASSWORD} > .password
770
773
771 # Initialize encrypted partition
774 # Initialize encrypted partition
772 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
775 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
773
776
774 # Open encrypted partition and setup mapping
777 # Open encrypted partition and setup mapping
775 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
778 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
776
779
777 # Secure delete password keyfile
780 # Secure delete password keyfile
778 shred -zu .password
781 shred -zu .password
779
782
780 # Update temporary loop device
783 # Update temporary loop device
781 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
784 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
782
785
783 # Wipe encrypted partition (encryption cipher is used for randomness)
786 # Wipe encrypted partition (encryption cipher is used for randomness)
784 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
787 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
785 fi
788 fi
786
789
787 # Build filesystems
790 # Build filesystems
788 mkfs.vfat "$FRMW_LOOP"
791 mkfs.vfat "$FRMW_LOOP"
789 mkfs.ext4 "$ROOT_LOOP"
792 mkfs.ext4 "$ROOT_LOOP"
790
793
791 # Mount the temporary loop devices
794 # Mount the temporary loop devices
792 mkdir -p "$BUILDDIR/mount"
795 mkdir -p "$BUILDDIR/mount"
793 mount "$ROOT_LOOP" "$BUILDDIR/mount"
796 mount "$ROOT_LOOP" "$BUILDDIR/mount"
794
797
795 mkdir -p "$BUILDDIR/mount/boot/firmware"
798 mkdir -p "$BUILDDIR/mount/boot/firmware"
796 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
799 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
797
800
798 # Copy all files from the chroot to the loop device mount point directory
801 # Copy all files from the chroot to the loop device mount point directory
799 rsync -a "${R}/" "$BUILDDIR/mount/"
802 rsync -a "${R}/" "$BUILDDIR/mount/"
800
803
801 # Unmount all temporary loop devices and mount points
804 # Unmount all temporary loop devices and mount points
802 cleanup
805 cleanup
803
806
804 # Create block map file(s) of image(s)
807 # Create block map file(s) of image(s)
805 if [ "$ENABLE_SPLITFS" = true ] ; then
808 if [ "$ENABLE_SPLITFS" = true ] ; then
806 # Create block map files for "bmaptool"
809 # Create block map files for "bmaptool"
807 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
810 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
808 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
811 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
809
812
810 # Image was successfully created
813 # Image was successfully created
811 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
814 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
812 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
815 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
813 else
816 else
814 # Create block map file for "bmaptool"
817 # Create block map file for "bmaptool"
815 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
818 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
816
819
817 # Image was successfully created
820 # Image was successfully created
818 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
821 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
819
822
820 # Create qemu qcow2 image
823 # Create qemu qcow2 image
821 if [ "$ENABLE_QEMU" = true ] ; then
824 if [ "$ENABLE_QEMU" = true ] ; then
822 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
825 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
823 QEMU_SIZE=16G
826 QEMU_SIZE=16G
824
827
825 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
828 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
826 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
829 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
827
830
828 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
831 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
829 fi
832 fi
830 fi
833 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant